ifndef LIBGOTCHA_PATH
LIBGOTCHA_PATH := $(dir $(lastword $(MAKEFILE_LIST)))
endif

ifndef ELFUTILS_PATH
ELFUTILS_PATH := /usr/lib/x86_64-linux-gnu/elfutils
endif

ifndef CP
CP := cp
endif

ifndef RUSTC
RUSTC := rustc
endif

ifndef RUSTFLAGS
RUSTFLAGS := -O
endif

lib%.so: %.o libgotcha.a
	$(CC) $(LDFLAGS) -shared -zdefs -zinitfirst -znoexecstack -ztext -static-libgcc -L. -L$(ELFUTILS_PATH) -Wl,-R$(ELFUTILS_PATH) -o $@ $< $(LDLIBS) -Wl,--whole-archive -lgotcha -Wl,--no-whole-archive -l$(LIBSTDRUST_SONAME) -ldl -lpthread -lc -lasm -lebl_x86_64

lib%.so: %.rs libgotcha.rlib
	$(RM) libgotcha.so
	$(RUSTC) $(RUSTFLAGS) --crate-type dylib -Clink-args="$(LDFLAGS) -zdefs -zinitfirst -ztext -Wl,-zlazy -L$(ELFUTILS_PATH) -Wl,-R$(ELFUTILS_PATH) -lasm -lebl_x86_64" -Cprefer-dynamic -Clinker=$(LIBGOTCHA_PATH)/cc -L. $<

libgotcha.%: $(LIBGOTCHA_PATH)/libgotcha.%
	$(CP) $< $@
